#ifndef __XAUDIOXAPOTEST_
#define __XAUDIOXAPOTEST_

#include <xaudio2.h>
#include "XAPOBase.h"

class __declspec( uuid("{5EB8D611-FF96-429d-8365-2DDF89A7C1CD}")) 
XAudioXAPOTest : public CXAPOBase{
public:
	XAudioXAPOTest( const XAPO_REGISTRATION_PROPERTIES* pRegistrationProperties ) : CXAPOBase( pRegistrationProperties ){};

	STDMETHOD( LockForProcess )( UINT32 InputLockedParameterCount, __in_ecount_opt(InputLockedParameterCount) const XAPO_LOCKFORPROCESS_BUFFER_PARAMETERS* pInputLockedParameters, UINT32 OutputLockedParameterCount, __in_ecount_opt(OutputLockedParameterCount) const XAPO_LOCKFORPROCESS_BUFFER_PARAMETERS* pOutputLockedParameters )
	{
		memcpy( &WaveformatEx, pInputLockedParameters[0].pFormat, sizeof( WAVEFORMATEX ) );
		return S_OK;
	};

	STDMETHOD_( void, UnlockForProcess )()
	{
	};

	STDMETHOD_( void, Process )( THIS_ UINT32 InputProcessParameterCount, __in_ecount_opt(InputProcessParameterCount) const XAPO_PROCESS_BUFFER_PARAMETERS* pInputProcessParameters, UINT32 OutputProcessParameterCount, __inout_ecount_opt(OutputProcessParameterCount) XAPO_PROCESS_BUFFER_PARAMETERS* pOutputProcessParameters, BOOL IsEnabled )
	{
		if( pInputProcessParameters->BufferFlags == XAPO_BUFFER_VALID ){
			for( UINT32 i = 0; i < pInputProcessParameters[0].ValidFrameCount * WaveformatEx.nChannels; ++i ) ( (float*)pInputProcessParameters[0].pBuffer )[i] *= 0.1f;
		}
	};

private:
	WAVEFORMATEX WaveformatEx;
};

#endif
